
#include "esc.hpp"
//#include "misc.hpp"
//#include "types.hpp"

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>

//extern map < string, string> args;

/***********************************************************************************************************/

esc::esc(map < string, string > &args)
//void esc::get_params(map < string, string > &args)
//void get_params(map < string, string > *args)
{
	map < string, string > :: iterator maiter;
	
	if((maiter = args.find("dataSetName")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg dataSetName");
	
	_dataSetName = (maiter->second);
	
	cout << "DATASET NAME IS " << _dataSetName << endl;
	
	if((maiter = args.find("labelsProvided")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg labelsProvided");
	
	_labelsProvided = stringToInt(maiter->second);
	
	//if((maiter = args.find("labelSetName")) == args.end())
	//	die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg labelSetName");
	//
	//_labelSetName = (maiter->second);
	
	if((maiter = args.find("dataSetDim")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg dim");
	
	_dataSetDim = stringToLong(maiter->second);
	
	if((maiter = args.find("dataSetSize")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg size");
	
	_dataSetSize = stringToLong(maiter->second);
	
	if((maiter = args.find("attrWiseClusCentFileName")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg attrWiseClusCentFileName");
	
	_attrWiseClusCentFileName = (maiter->second);
	
	if((maiter = args.find("attrWiseClusLabelsFileName")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg attrWiseClusLabelsFileName");
	
	_attrWiseClusLabelsFileName = (maiter->second);
	
	if((maiter = args.find("noneligibleAttrFileName")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg noneligibleAttrFileName");
	
	_noneligibleAttrFileName = (maiter->second);
	
	if((maiter = args.find("noneligibleClusFileName")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg noneligibleClusFileName");
	
	_noneligibleClusFileName = (maiter->second);
	
	if((maiter = args.find("numLevels")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg numLevels");
	
	_numLevels = stringToInt(maiter->second);
	
	if((maiter = args.find("numObjectives0")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg numObjectives0");
	
	_numObjectives0 = stringToInt(maiter->second);
	
	if((maiter = args.find("numObjectives1")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg numObjectives1");
	
	_numObjectives1 = stringToInt(maiter->second);
	
	if((maiter = args.find("doDistortion")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg doDistortion");
	
	_doDistortion = stringToInt(maiter->second);
	
	if((maiter = args.find("doConnectivity")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg doConnectivity");
	
	_doConnectivity = stringToInt(maiter->second);
	
	if((maiter = args.find("doAttrCount")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg doAttrCount");
	
	_doAttrCount = stringToInt(maiter->second);
	
	if((maiter = args.find("doClusterCount")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg doClusterCount");
	
	_doClusterCount = stringToInt(maiter->second);
	
	if((maiter = args.find("doSubsampling")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg doSubsampling");
	
	_doSubsampling = stringToInt(maiter->second);
	
	if((maiter = args.find("pointPopSize")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pointPopSize");
	
	_pointPopSize = stringToInt(maiter->second);
	
	if((maiter = args.find("hostPopSize")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg hostPopSize");
	
	_hostPopSize = stringToInt(maiter->second);
	
	if((maiter = args.find("minSymbionts")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg minSymbionts");
	
	_minSymbionts = stringToInt(maiter->second);
	
	if((maiter = args.find("maxSymbionts")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg maxSymbionts");
	
	_maxSymbionts = stringToInt(maiter->second);
	
	if((maiter = args.find("pc_initial")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pc_initial");
	
	_pc_initial = stringToDouble(maiter->second);
	
	if((maiter = args.find("pc_final")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pc_final");
	
	_pc_final = stringToDouble(maiter->second);
	
	if((maiter = args.find("pm_initial")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pm_initial");
	
	_pm_initial = stringToDouble(maiter->second);
	
	if((maiter = args.find("pm_final")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pm_final");
	
	_pm_final = stringToDouble(maiter->second);
	
	if((maiter = args.find("psd")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg psd");
	
	_psd = stringToDouble(maiter->second);
	
	if((maiter = args.find("psa")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg psa");
	
	_psa = stringToDouble(maiter->second);
	
	if((maiter = args.find("pss")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pss");
	
	_pss = stringToDouble(maiter->second);
	
	if((maiter = args.find("pmlm")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pmlm");
	
	_pmlm = stringToDouble(maiter->second);
	
	if((maiter = args.find("minAttributes")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg minAttributes");
	
	_minAttributes = stringToInt(maiter->second);
	
	if((maiter = args.find("maxAttributes")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg maxAttributes");
	
	_maxAttributes = stringToInt(maiter->second);
	
	if((maiter = args.find("pad")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pad");
	
	_pad = stringToDouble(maiter->second);
	
	if((maiter = args.find("paa")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg paa");
	
	_paa = stringToDouble(maiter->second);
	
	if((maiter = args.find("pas")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg pas");
	
	_pas = stringToDouble(maiter->second);
	
	if((maiter = args.find("plc")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg plc");
	
	_plc = stringToDouble(maiter->second);
	
	if((maiter = args.find("numGenerations0")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg _numGenerations0");
	
	_numGenerations0 = stringToLong(maiter->second);
	
	if((maiter = args.find("numGenerations1")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg _numGenerations1");
	
	_numGenerations1 = stringToLong(maiter->second);
	
	if((maiter = args.find("useAttrProbLrng")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg useAttrProbLrng");
	
	_useAttrProbLrng = stringToInt(maiter->second);
	
	if((maiter = args.find("attrProbLrngRate")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg attrProbLrngRate");
	
	_attrProbLrngRate = stringToDouble(maiter->second);
	
	if((maiter = args.find("seed")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg seed");
	
	_seed = stringToInt(maiter->second);
	
	if((maiter = args.find("statMod")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg statMod");
	
	_statMod = stringToInt(maiter->second);
	
	if((maiter = args.find("maxAttempts")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg maxAttempts");
	
	_maxAttempts = stringToInt(maiter->second);
	
	if((maiter = args.find("epsilon")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg epsilon");
	
	_epsilon = stringToDouble(maiter->second);
	
	if((maiter = args.find("infinity")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg infinity");
	
	_infinity = stringToDouble(maiter->second);
	
	if((maiter = args.find("symbsToUse")) == args.end())
		die(__FILE__, __FUNCTION__, __LINE__, "cannot find arg symbsToUse");
	
	_symbsToUse = stringToInt(maiter->second);
	
	
	cout << "arg dataSetName " << _dataSetName << endl;
	cout << "arg labelsProvided " << _labelsProvided << endl;
	//	cout << "arg labelSetName " << _labelSetName << endl;
	cout << "arg dataSetDim " << _dataSetDim << endl;
	cout << "arg dataSetSize " << _dataSetSize << endl;
	
	cout << "arg attrWiseClusCentFileName " << _attrWiseClusCentFileName << endl;
	cout << "arg attrWiseClusLabelsFileName " << _attrWiseClusLabelsFileName << endl;
	cout << "arg noneligibleAttrFileName " << _noneligibleAttrFileName << endl;
	cout << "arg noneligibleClusFileName " << _noneligibleClusFileName << endl;
	
	cout << "arg numLevels " << _numLevels << endl;
	cout << "arg numObjectives0 " << _numObjectives0 << endl;
	cout << "arg numObjectives1 " << _numObjectives1 << endl;
	
	cout << "arg doDistortion " << _doDistortion << endl;
	cout << "arg doConnectivity " << _doConnectivity << endl;
	cout << "arg doAttrCount " << _doAttrCount << endl;
	cout << "arg doClusterCount " << _doClusterCount << endl;
	
	cout << "arg doSubsampling " << _doSubsampling << endl;
	cout << "arg Psize " << _pointPopSize << endl;
	
	cout << "arg Hsize " << _hostPopSize << endl;
	
	cout << "arg minSymbionts " << _minSymbionts << endl;
	cout << "arg maxSymbionts " << _maxSymbionts << endl;
	
	cout << "arg pc_initial " << _pc_initial << endl;
	cout << "arg pc_final " << _pc_final << endl;
	cout << "arg pm_initial " << _pm_initial << endl;
	cout << "arg pm_final " << _pm_final << endl;
	
	cout << "arg psd " << _psd << endl;
	cout << "arg psa " << _psa << endl;
	cout << "arg pss " << _pss << endl;
	cout << "arg pmlm " << _pmlm << endl;
	
	cout << "arg minAttributes " << _minAttributes << endl;
	cout << "arg maxAttributes " << _maxAttributes << endl;
	
	cout << "arg pad " << _pad << endl;
	cout << "arg paa " << _paa << endl;
	cout << "arg pas " << _pas << endl;
	cout << "arg plc " << _plc << endl;
	
	cout << "arg numGenerations0 " << _numGenerations0 << endl;
	cout << "arg numGenerations1 " << _numGenerations1 << endl;
	
	cout << "arg useAttrProbLrng " << _useAttrProbLrng << endl;
	
	cout << "arg attrProbLrngRate " << _attrProbLrngRate << endl;
	
	cout << "arg seed " << _seed << endl;
	
	cout << "arg statMod " << _statMod << endl;
	
//	cout << "arg maxTries " << _maxTries << endl;
	
	cout << "arg maxAttempts " << _maxAttempts << endl;
	
	cout << "arg epsilon " << _epsilon << endl;
	
	cout << "arg infinity " << _infinity << endl;
	
	cout << "arg symbsToUse " << _symbsToUse << endl;
	
	if(_labelsProvided != 0 && _labelsProvided != 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg labelsProvided != 0 && labelsProvided != 1");  
	
	if(_dataSetDim < 1 || _dataSetDim > INPUTS)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg dim < 1 || dim > INPUTS");
	if(_dataSetSize < 1 || _dataSetSize < 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg size < 1 || size < 1");
	
	if(_numLevels < 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg numLevels < 1");
	
	if(_numObjectives0 > 4)//_numObjectives0 < 1 || 
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg numObjectives0 > 4");//numObjectives0 < 1 || 
	if(_numObjectives1 < 1 || _numObjectives1 > 4)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg numObjectives1 < 1 || numObjectives1 > 4");
		
	if(_doDistortion != 0 && _doDistortion != 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg doDistortion != 0 && doDistortion != 1");  
	if(_doConnectivity != 0 && _doConnectivity != 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg doConnectivity != 0 && doConnectivity != 1");  
	if(_doAttrCount != 0 && _doAttrCount != 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg doAttrCount != 0 && doAttrCount != 1");  
	if(_doClusterCount != 0 && _doClusterCount != 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg doClusterCount != 0 && doClusterCount != 1");  
	
	if(_pointPopSize < 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pointPopSize < 2");
	
	if(_hostPopSize < 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg hostPopSize < 2");
	
	if(_minSymbionts < 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg minSymbionts < 2");
	if(_maxSymbionts > 100)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg maxSymbionts > 100");
	
	if(_pc_initial < 0 || _pc_initial > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pc_initial < 0 || pc_initial > 1");
	if(_pc_final < 0 || _pc_final > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pc_final < 0 || pc_final > 1");
	if(_pm_initial < 0 || _pm_initial > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pm_initial < 0 || pm_initial > 1");
	if(_pm_final < 0 || _pm_final > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pm_final < 0 || pm_final > 1");
	
	// Initial value for _pc and _pm. Will be updated at the end of each generation.
	_pc = _pc_final;
	_pm = _pm_final;
	
	if(_psd < 0 || _psd > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg psd < 0 || psd > 1");
	if(_psa < 0 || _psa > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg psa < 0 || psa > 1");
	if(_pss < 0 || _pss > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pss < 0 || pss > 1");
	
	if(_minAttributes < 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg minAttributes < 2");
	if(_maxAttributes > _dataSetDim)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg maxAttributes > dataSetDim");
	
	if(_pad < 0 || _pad > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pad < 0 || pad > 1");
	if(_paa < 0 || _paa > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg paa < 0 || paa > 1");
	if(_pas < 0 || _pas > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg pas < 0 || pas > 1");
	if(_plc < 0 || _plc > 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg plc < 0 || plc > 1");
	
	if(_numGenerations0 < 0) 
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg numGenerations0 < 0");  
	
	if(_numGenerations1 < 1) 
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg numGenerations1 < 1");  
	
	if(_useAttrProbLrng != 0 && _useAttrProbLrng != 1) 
	{
		cout << "_useAttrProbLrng = " << _useAttrProbLrng << endl;
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg useAttrProbLrng != 0 && useAttrProbLrng != 1");
	}
	
	if(_attrProbLrngRate < 0 || _attrProbLrngRate >= 2) 
	{
		cout << "_attrProbLrngRate = " << _attrProbLrngRate << endl;
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg attrProbLrngRate <= 0 || attrProbLrngRate >= 2");
	}
	
	if(_seed < 1) 
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg seed < 1");  
	
	if(_statMod < 1) 
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg statMod < 1");  
	
	if(_maxAttempts < 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg maxAttempts < 2");
	
	if(_epsilon <= 0 || _epsilon >= 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg epsilon <= 0 || epsilon >= 1");

	if(_infinity < 1)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg infinity < 1");
	
	if(_symbsToUse < 0 || _symbsToUse > 2)
		die(__FILE__, __FUNCTION__, __LINE__, "bad arg symbsToUse < 0 && symbsToUse > 2");  
	
	
	/*
	 Placeholder null pointers that should never get accessed.
	 Set this way because element i is set to contain individuals
	 evolved at level i - 1 which does not make sense for element 0.
	 */
	//	_pLevel.push_back(0);
	//	_mLevel.push_back(0);
	//	_lLevel.push_back(0);
	
}

/***********************************************************************************************************/

esc::~esc()
{
	for(long i = 0; i < (int)_pointSet.size(); i++)
    {
		delete [] _pointSet[i];
		delete _pointSet[i];
    }
	
//	delete _labelSet;
	
	for(int i = 0; i < numLabels(); i++)
		delete _index[i];
}

/***********************************************************************************************************/

/* Function to read the dataset from file. */
void esc::readDataSet()
{
	
#ifdef DATASET
	cout << "esc::readDataSet() start." << endl;
#endif
	
	string file = _dataSetName;
	
	set < long > labels;
	set < long > :: iterator laiter;
	
	map < long, long > labelCount;
	
	_pointSet.reserve(_dataSetSize);
	_labelSet.reserve(_dataSetSize);
	
	ifstream infile(file.c_str(), ios::in);
	
	if(infile == 0)
		die(__FILE__, __FUNCTION__, __LINE__, "cannot open dataset file!");
	
	for(long i = 0; i < _dataSetSize; i++)
    {
		_pointSet[i] = new double[_dataSetDim];
		
#ifdef DATASET
		cout << "Pattern " << i << ":";
#endif
		
		for(int j = 0; j < _dataSetDim; j++)
		{
			if(infile == 0)
				die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern.");
			
			infile >> _pointSet[i][j];
			
#ifdef DATASET
			cout << " " << _pointSet[i][j];
#endif
		}
		
		if(infile == 0)
			die(__FILE__, __FUNCTION__,  __LINE__, "missing pattern class.");
		
		if(_labelsProvided == 1)
		{
			infile >> _labelSet[i];
			
#ifdef DATASET
			cout << " " << _labelSet[i];
#endif
			
			labels.insert(_labelSet[i]);
			
			if(labelCount.count(_labelSet[i]) == 0)
				labelCount.insert(map < long, long > :: value_type(_labelSet[i], 1));
			else
				labelCount[_labelSet[i]]++;
		}
		
#ifdef DATASET
		cout << endl;
#endif
		
    }
	
	if(_labelsProvided == 1)
	{
		for(laiter = labels.begin(); laiter != labels.end(); laiter++)
			_uniqueLabels.push_back(*laiter);
		
		/* Sort labels, then create label->index map. */
		sort(_uniqueLabels.begin(), _uniqueLabels.end());
		
		for(long i = 0; i < (long)_uniqueLabels.size(); i++)
		{
			_labelMap.insert(map < long, long > :: value_type(_uniqueLabels[i], i));
			_labelCount.push_back(labelCount[_uniqueLabels[i]]);
			
			cout << "dataset " << file << " label at index " << i << " is " << _uniqueLabels[i] ;
			cout << " number of patterns of " << _uniqueLabels[i] << " is " << _labelCount[i];
			cout << " (=" << getLabelCount(_uniqueLabels[i]) << ")" << endl;
		}
	}
	
	infile.close();
	
	/* 
	 PFAIL = ((_dataSetSize - 1) / (_dataSetSize)) ^ _maxTries
	 Sample the dataset uniformly. PFAIL represents the probability
	 of not sampling a specific point after _maxTries attempts.
	 Use this in initUniformPointLabel since in theory could always sample
	 the same point, and if the point is already in usedIds, then would fail.
	 */
	_maxTries = (long) (log10(PFAIL) / log10((double) (_dataSetSize - 1) / _dataSetSize));
	
	cout << "maxTries " << _maxTries << " (PFAIL = " << PFAIL << ")" << endl;
	
	/* Build index. */
	
	if(_labelsProvided == 1)
	{
		for(int i = 0; i < numLabels(); i++)
			_index.push_back(new vector < long > );
		
		for(long i = 0; i < _dataSetSize; i++)
			_index[getLabelIndex(_labelSet[i])]->push_back(i);
		
		for(int i = 0; i < numLabels(); i++)
			cout << "index " << i << " label " << _uniqueLabels[i] << " _index[getLabelIndex(_labels[i])]->size() " << _index[getLabelIndex(_uniqueLabels[i])]->size() << endl;
	}
	
#ifdef DATASET
	cout << "esc::readDataSet() first data item:";
	for(int i = 0; i < _dataSetDim; i++)
		cout << " " << *(_pointSet[0] + i);
	if(_labelsProvided == 1)
		cout << " " << _labelSet[0] << endl;
	
	cout << "esc::readDataSet() last data item:";
	for(int i = 0; i < _dataSetDim; i++)
		cout << " " << *(_pointSet[_dataSetSize - 1] + i);
	if(_labelsProvided == 1)
		cout << " " << _labelSet[_dataSetSize - 1] << endl;
	
	if(_labelsProvided == 1)
	{
		cout << "esc::readDataSet() size " << _pointSet.size() << " labels";
		for(int i = 0; i < numLabels(); i++)
			cout << " " << getLabelIndex(getLabel(i)) << "/" << getLabel(i) << "/" << getLabelCount(getLabel(i)) << "/" << _index[i]->size();
		cout << endl;
	}
#endif
	
#ifdef DATASET
	cout << "esc::readDataSet() end." << endl;
#endif
	
}

/***********************************************************************************************************/

/* Function to normalize the dataset */
void esc::normalizeDataSet()
{
	
#ifdef DATASET
	cout << "esc::normalizeDataSet() start." << endl;
#endif
	
	for(int i=0; i < _dataSetDim; i++)
	{
		double minimum = 1000;
		double maximum = -1000;
		
		for(int j=0; j < _dataSetSize; j++)
		{
			if(_pointSet[j][i] < minimum)
				minimum = _pointSet[j][i];
			if(_pointSet[j][i] > maximum)
				maximum = _pointSet[j][i];
		}
		
#ifdef DATASET
		cout << " attribute " << i << " Min = " << minimum << " and Max = " << maximum << endl;
#endif
		
		for(int j=0; j < _dataSetSize; j++)
		{
			_pointSet[j][i] = (_pointSet[j][i]-minimum) / (maximum-minimum);// + minimum;
		}
	}
	
#ifdef DATASET
	cout << "esc::normalizeDataSet() end." << endl;
#endif
}

/***********************************************************************************************************/

/* Function to read 1-D cluster centroids. */
void esc::readAttrWiseClusCent()
{
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusCent() start." << endl;
#endif
	
	string file = _attrWiseClusCentFileName;
	
	_attrWiseClusCent.reserve(_dataSetDim);
	_numClusPerAttr.reserve(_dataSetDim);
	
	_maxClusPerAttr = 0;
	
	ifstream infile(file.c_str(), ios::in);
	
	if(infile == 0)
		die(__FILE__, __FUNCTION__, __LINE__, "cannot open attribute-wise cluster centroids file!");
	
	for(long i = 0; i < _dataSetDim; i++)
    {
		infile >> _numClusPerAttr[i];
		
#ifdef DATASET
		cout << "Cluster centroids at attribute " << i << " = " << _numClusPerAttr[i] << ": ";
#endif
		
		/* This wil be reached for first attribute. */
		if(_numClusPerAttr[i] > _maxClusPerAttr)
			_maxClusPerAttr = _numClusPerAttr[i];
		
		_attrWiseClusCent[i] = new double[_numClusPerAttr[i]];
		
		for(int j = 0; j < _numClusPerAttr[i]; j++)
		{
			if(infile == 0)
				die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern");
			
			infile >> _attrWiseClusCent[i][j];
			
#ifdef DATASET
			cout << " " << _attrWiseClusCent[i][j];
#endif
		}
#ifdef DATASET
		cout << endl;
#endif
		
	}
	
	infile.close();
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusCent() first pattern:";
	for(int i = 0; i < _numClusPerAttr[0]; i++)
		cout << " " << *(_attrWiseClusCent[0] + i);
	cout << endl;
	
	cout << "esc::ReadAttrWiseClusCent() last pattern:";
	for(int i = 0; i < _numClusPerAttr[_dataSetDim - 1]; i++)
		cout << " " << *(_attrWiseClusCent[_dataSetDim - 1] + i);
	cout << endl;
#endif
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusCent() end." << endl;
#endif

}

/***********************************************************************************************************/

/* Function to read 1-D cluster labels. */
void esc::readAttrWiseClusLabels()
{
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusLabels() start." << endl;
#endif
	
	string file = _attrWiseClusLabelsFileName;
	
	_attrWiseClusLabels.reserve(_dataSetSize);
	
	ifstream infile(file.c_str(), ios::in);
	
	if(infile == 0)
		die(__FILE__, __FUNCTION__, __LINE__, "cannot open attribute-wise cluster labels file!");
	
	for(long i = 0; i < _dataSetSize; i++)
	{
		_attrWiseClusLabels[i] = new long[_dataSetDim];
		
#ifdef DATASET
		cout << "Pattern " << i << " 1D cluster labels:";
#endif
		
		for(int j = 0; j < _dataSetDim; j++)
		{
			if(infile == 0)
				die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern");
			
			infile >> _attrWiseClusLabels[i][j];
			
#ifdef DATASET
			cout << " " << _attrWiseClusLabels[i][j];
#endif
		}
		
#ifdef DATASET
		cout << endl;
#endif
		
	}
	
	infile.close();
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusLabels() first pattern:";
	for(int i = 0; i < _dataSetDim; i++)
		cout << " " << *(_attrWiseClusLabels[0] + i);
	cout << endl;
	
	cout << "esc::ReadAttrWiseClusLabels() last pattern:";
	for(int i = 0; i < _dataSetDim; i++)
		cout << " " << *(_attrWiseClusLabels[_dataSetSize - 1] + i);
	cout << endl;
#endif
	
#ifdef DATASET
	cout << "esc::ReadAttrWiseClusLabels() end." << endl;
#endif

}

/***********************************************************************************************************/

/* Read Noneligible attributes. */
void esc::readNoneligibleAttr()
{
	
#ifdef DATASET
	cout << "esc::ReadNoneligibleAttr() start." << endl;
#endif
	
	string file = _noneligibleAttrFileName;
	
	_noneligibleAttr.reserve(_dataSetDim);
	
	ifstream infile(file.c_str(), ios::in);
	
	if(infile == 0)
		die(__FILE__, __FUNCTION__, __LINE__, "cannot open noneligible attribute indexes file!");
	
#ifdef DATASET
	cout << "Non-eligibility of the attributes:";
#endif
	
	for(long i = 0; i < _dataSetDim; i++)
	{
		if(infile == 0)
			die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern");
		
		infile >> _noneligibleAttr[i];
		
		if(_useAttrProbLrng)// && !_noneligibleAttr[i]
			_attrProbs.push_back(double(1.0));
		
		
#ifdef DATASET
		cout << " " << _noneligibleAttr[i];
#endif
	}
	
#ifdef DATASET
	cout << endl;
#endif
	
	infile.close();
	
	// normalize attrProbs vector
	double tempSum = 0;
	
	if(_useAttrProbLrng)
	{
		for(int j=0; j < (int)_attrProbs.size(); j++)
			tempSum += _attrProbs[j];
		
		cout << "esc::readNoneligibleAttr() => Attribute Probabilities (tempSum=" << tempSum << "): ";
		for(int j=0; j < (int)_attrProbs.size(); j++)
		{
			_attrProbs[j] = _attrProbs[j] / tempSum;
			cout << _attrProbs[j] << ", ";
		}
		cout << endl;
	}
	
#ifdef DATASET
	cout << "esc::ReadNoneligibleAttr() first pattern:";
	cout << " " << _noneligibleAttr[0] << endl;
	
	cout << "esc::ReadNoneligibleAttr() last pattern:";
	cout << " " << _noneligibleAttr[_dataSetDim - 1] << endl;
#endif
	
#ifdef DATASET
	cout << "esc::ReadNoneligibleAttr() end." << endl;
#endif

}

/***********************************************************************************************************/

/* Read Noneligible 1-D cluster centroids. */
void esc::readNoneligibleClus()
{

#ifdef DATASET
	cout << "esc::ReadNoneligibleClus() start." << endl;
#endif
	
	string file = _noneligibleClusFileName;
	
	_noneligibleClus.reserve(_dataSetDim);
	
	long temp;
	
	ifstream infile(file.c_str(), ios::in);
	
	if(infile == 0)
		die(__FILE__, __FUNCTION__, __LINE__, "cannot open noneligible cluster centroids file!");
	
	for(long i = 0; i < _dataSetDim; i++)
    {
		_noneligibleClus[i] = new long[_numClusPerAttr[i]];
		
		/*
		 This is used if NoneligibileClus file follows the AttrWiseClusCent file format. 
		 Reads in the number of cluster centroids for the current attribute, which is already stored in _numClusPerAttr[i].
		 */
		//infile >> temp;
		
#ifdef DATASET
		cout << "Non-eligibility of the 1D cluster centroids for attribute " << i << " = " << _numClusPerAttr[i] << ":";
#endif
		
		for(int j = 0; j < _numClusPerAttr[i]; j++)
		{
			if(infile == 0)
				die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern");
			
			infile >> _noneligibleClus[i][j];
			
#ifdef DATASET
			cout << " " << _noneligibleClus[i][j];
#endif
		}
		
#ifdef DATASET
		cout << endl;
#endif
		
		/* 
		 If NoneligibileClus file follows the AttrWiseClusCent file format, the following loop should be removed,
		 because the rest of the binary values are not used.
		 */
		
		for(int j = _numClusPerAttr[i]; j < _maxClusPerAttr; j++)
		{
			if(infile == 0)
				die(__FILE__, __FUNCTION__,  __LINE__, "bad pattern");
			
			infile >> temp;
		}
		
	}
	
	infile.close();
	
#ifdef DATASET
	cout << "esc::ReadNoneligibleClus() first pattern:";
	for(int i = 0; i < _numClusPerAttr[0]; i++)
		cout << " " << *(_noneligibleClus[0] + i);
	cout << endl;
	
	cout << "esc::ReadNoneligibleClus() last pattern:";
	for(int i = 0; i < _numClusPerAttr[_dataSetDim - 1]; i++)
		cout << " " << *(_noneligibleClus[_dataSetDim - 1] + i);
	cout << endl;
#endif
	
#ifdef DATASET
	cout << "esc::ReadNoneligibleClus() end." << endl;
#endif

}

/***********************************************************************************************************/

long esc::getLabelIndex(long c)
//long getLabelIndex(long c)
{
	map < long, long >::iterator iter = _labelMap.find(c); 
	
	if(iter == _labelMap.end()) 
		die(__FILE__, __FUNCTION__, __LINE__, "bad label"); 
	
	return (*iter).second; 
}

/***********************************************************************************************************/

/* Rndom subset selection. */
/*
void esc::RSS()
{

//	cout << "esc::RSS() => enter." << endl;
	
	int temp;
	
	_activePoints.clear();
	_activePoints.resize(_pointPopSize);
	
#ifdef DEBUGGING
	for(int i=0; i < (int) _activePoints.size(); i++)
		cout << _activePoints[i] << ", ";
	cout << endl;
#endif
	
	_activePoints[0] = (int) (drand48() * _dataSetSize);
	
	// randomly select _pointPopSize unique points
	for(int i=0; i < (int) _pointPopSize; i++)
	{
		temp = (int) (drand48() * _dataSetSize);
		
		while(find(_activePoints.begin(),_activePoints.end(),temp) != _activePoints.end())
			temp = (int) (drand48() * _dataSetSize);
			
		_activePoints[i] = temp;
	}
	
	// sort the selected points
	sort(_activePoints.begin(), _activePoints.end());
	
//#ifdef DEBUGGING
	cout << "esc::RSS() => _activePoints.size() = " << _activePoints.size() << endl;
	for(int i=0; i < (int) _activePoints.size(); i++)
		cout << _activePoints[i] << ", ";
	cout << endl;
//#endif
	
//	cout << "esc::RSS() => exit." << endl;
	
}
*/
/***********************************************************************************************************/

/* Rndom subset selection. */
void esc::RSS()
{
	
	//	cout << "esc::RSS() => enter." << endl;
	
	int temp;
	
	_activePoints.clear();
	//	_activePoints.resize(_pointPopSize, -1);
	
#ifdef DEBUGGING
	for(int i=0; i < (int) _activePoints.size(); i++)
		cout << _activePoints[i] << ", ";
	cout << endl;
#endif
	
	_activePoints.push_back((int) (drand48() * _dataSetSize));
	
	// randomly select _pointPopSize unique points
	for(int i=1; i < (int) _pointPopSize; i++)
	{
		temp = (int) (drand48() * _dataSetSize);
		
		while(find(_activePoints.begin(),_activePoints.end(),temp) != _activePoints.end())
			temp = (int) (drand48() * _dataSetSize);
		
		_activePoints.push_back(temp);
	}
	
	// sort the selected points
	sort(_activePoints.begin(), _activePoints.end());
	
//#ifdef DEBUGGING
	cout << "esc::RSS() => _activePoints.size() = " << _activePoints.size() << endl;
	for(int i=0; i < (int) _activePoints.size(); i++)
		cout << _activePoints[i] << ", ";
	cout << endl;
//#endif
	
	//	cout << "esc::RSS() => exit." << endl;
	
}

/***********************************************************************************************************/

void esc::go()
//void esc::go(map < string, string > & args)
{
	
	//ostringstream oss;
	
	/**** Read input files; data set, labels set, attribute-wise cluster centroids, ... ****/
	//	get_params(args);
	
	/* Read data set from file. */
	readDataSet();
	
	/* Read labels (if provided in a different file than the data set). */
	//if(_labelsProvided == 1)
	//	readLabelSet();
	
	/* Do the RSS subsampling if _doSubsampling is set, otherwise use all points (i.e. all points are active) */
	if(_doSubsampling)
		RSS();
	else
	{
		_pointPopSize = _dataSetSize;
		
		_activePoints.clear();
		_activePoints.resize(_dataSetSize);
		
		for(int i=0; i < (int) _dataSetSize; i++)
			_activePoints[i] = i;
	}

	
	/* Read 1-D cluster centroids' file name. */
	readAttrWiseClusCent();
	
	/* Read 1-D cluster labels' file name. */
	readAttrWiseClusLabels();
	
	/* Read Noneligible attributes file name. */
	readNoneligibleAttr();
	
	/* Read Noneligible 1-D cluster centroids' file name. */
	readNoneligibleClus();
	
	cout << "esc::go() => dataSetDim = " << _dataSetDim << ", and dataSetSize = " << _dataSetSize << endl;
	
}

/***********************************************************************************************************/

