
//#include "esc.hpp"
#include "types.hpp"
#include "misc.hpp"
#include "permute.hpp"

#include <iostream>
#include <iomanip>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

// My declarations
//vector<int> uniqueIndexes;
extern front bestFront;
vector <int> pfLabels;

extern esc *model;


/***********************************************************************************************************/

front::front()
{
	frontnumber = -1;
}

/***********************************************************************************************************/

front::front(int f)
{
	frontnumber = f;
}

/***********************************************************************************************************/

front::front(solution *s, int f)
{
	frontnumber = f;
	s->setFrontNumber(frontnumber);
	indexes.push_back(s);
}

/***********************************************************************************************************/

int front::print(int t=0)
{
	cout << "front::print() enter." << endl;
	
	int temp;
	
	//vector <int> front_sizes(max(model->_dataSetDim + 1, _maxClusPerAttr), 0);
	vector <int> front_sizes(max(model->_maxAttributes+1, model->_maxSymbionts+1), 0);
	
	cout << "Number of solutions on this front: " << indexes.size() << endl;
	
	for(int i=0; i < (int)indexes.size(); i++)
	{
		cout << "Individual/Solution (" << i << "):" << endl;
		
		temp = (*indexes[i]).print(t);
		
		front_sizes[temp]++;
	}
	
	if(t == 0)
	{
		cout << "Number of solutions on this front = " << indexes.size() << endl;
		for(size_t k=1; k < front_sizes.size(); k++)
		{
			if(front_sizes[k] != 0)
				cout << "Number of inds with " << k << " genes are: " << front_sizes[k] << endl;
		}
	}
	
	cout << "front::print() exit." << endl;
	
	return (int)indexes.size();
}

/***********************************************************************************************************/

void front::swap(front &sf)
{
	int tmp;
	tmp = frontnumber;
	frontnumber = sf.frontnumber;
	sf.frontnumber = tmp;

	indexes.swap(sf.indexes);
}

/***********************************************************************************************************/

/*
vector <int> front::uniqueSolutionsIndexes()
{
	// At the end of this function unique would be like [0 0 1 1 0 1 ...], and 
	// unique_indexes would be like [2 3 5 ...] corresponding to the unique vector
	
	cout << "front::uniqueSolutionsIndexes() enter." << endl;
	
	vector <int> unique(indexes.size(), -1);
	int num_uniques = 0;

	for(int i=0; i < (int)indexes.size(); i++)
	{
		if(unique[i] == -1)
		{
			num_uniques++;
			unique[i] = 1;
			for(size_t j=i+1; j < indexes.size(); j++)
				if((*indexes[i]) == (*indexes[j]))
					unique[j] = 0;
		}
	}
	
	unique_indexes.clear();
	unique_indexes.resize(num_uniques, -1);
	
	int j = 0;
	
	for(int i=0; i < (int)unique.size(); i++)
	{
		if(unique[i] == 1)
		{
			unique_indexes[j++] = i;
		}
	}
	
	cout << "number of unique nondominated solutions are: " << setw(3) << num_uniques << endl;
	for(int i=0; i < (int)unique_indexes.size(); i++)
		cout << "uniqueIndexes[" << i << "]: " << setw(3) << unique_indexes[i] << endl;
	
	cout << "front::uniqueSolutionsIndexes() exit." << endl;
	
	return unique_indexes;
}
*/

/***********************************************************************************************************/

/*
vector <int> front::paretoFrontLabelAssignment()
{
	// a value of -2 means that an instance has not been associated with any SC
	// a value of -1 means that an instance has been associated with more than one SC
	// any value between 0 and n  means that an instance has been associated with one SC
	pfLabels.reserve(model->_dataSetSize);
	vector<int> pfUniqueSubClsts = bestFront.getUniqueIndexes();
	
	for(int j=0; j < (int)pfUniqueSubClsts.size(); j++)
	{
		// subspaceClusters (solutions) on pareto front are available now :)
		vector <int> temp = bestFront[pfUniqueSubClsts[j]].evaluate();
		for(int i=0; i < (int)temp.size(); i++)
		{
			if(pfLabels[temp[i]] != -1)
				pfLabels[temp[i]] = -2;
			else
				pfLabels[temp[i]] = j; // We are using the offset of the SC in the "uniqueIndexes" now, i.e. pfLabels[i]=3 states that instance i belongs to 3rd unique SC on pareto front, which may not be the 3rd SC on PF. We could instead use the indexes from "bestFront"
		}
	}

//	cout << "Now printing pareto front labels:" << endl;
//	for(int i=0; i < (int)pfLabels.size(); i++)
//		cout << pfLabels[i] << endl;

	return pfLabels;
}
*/

/***********************************************************************************************************/

