
#ifndef _PERMUTE_HPP
#define _PERMUTE_HPP

#include <vector>
#include <cstddef>
#include <stdlib.h>

//#include "ran1.hpp"


template <class T>
vector<T> permutation(vector<T> &W, size_t s, size_t e)
{
	vector<T> V;
	vector<size_t> iv;
	
	iv.reserve(e-s);
	
	for(size_t i=s; i < e; i++)
	{
		iv.push_back(i);
		//cout << iv[i] << endl;
	}
	
	//cout << "Size of iv is: " << iv.size() << endl;
	
	for(size_t i=0; i < iv.size()-1; i++)
	{
		int tmp, rinx;
		
//		rinx = ran1int(i, iv.size()-1);
		rinx = (int) (i + (drand48() * (iv.size() - i)));
		
		tmp = iv[i];
		iv[i] = iv[rinx];
		iv[rinx] = tmp;
	}
/*	
	cout << "Permutated !" << endl;
	for(size_t i=0; i < iv.size(); i++)
	{
		cout << iv[i] << endl;
	}
*/	
	V.reserve(e-s);
	
	for(size_t i=0; i < e-s; i++) 
		V.push_back(W[iv[i]]);
	
	return V;
	
}

#endif

